
#define Version "2020_1112"
// ATTENTION au codage ascii des fichier TXT
// doit etre en ANSI et non utf8
// avec cluster= secteur de 512 bytes
// voir
// https://openlabpro.com/guide/raw-sd-readwrite-using-pic-18f4550/
//https://www.edaboard.com/threads/sd-card-initialization-failed-help.395564/
//SD Card Initialization failed. Help.
//05/11/2020         Thread starter Rickooo  Start date Yesterday at 5:44 PM

//#define Version "2020_1104"
/*
 * Project Name:    FAT32 Library
 * Copyright:    (c) MikroElektronika, 2018.
 * Revision History:    20110826 - initial release
 * Description:
    This simple example demonstrates the use of FAT32 Library
    on microSD cards via SPI hardware interface and folder content
    display via UART module.
    Files and folders are created and removed; files are read,
    written, their content sent to PC via  UART.
 * Original V.O. Test configuration:
    MPU:            P18F87K22
    Dev. Board:     EasyPIC Pro7
    Oscillator:     HS, 16.0000MHz
    Ext. Modules:   MicroSD click
    SW:             mikroC PRO for PIC
 rev Nov 2020 :
   * Notes:
    Rev by paulfjujo
    pour 18F26K22 mont sur carte BASE 18F26K22
    FOSC interne 16MHz x PLL => 64MHz
    Carte Scandisk 2GB type 2  , prformat en FAT32 sous DOS (Win10)
    avec creation de 2 fichier *.txt dessus
    Liaison SPI classique , mais  CS sur RC0 ( MCU en 28 pins seulement !)
    */

// 2 Tests  : File TEST + LNF_TEST ->compile OK
// mais bloque sur ligne trop longue sur terminal
// reduction drastique du nombre d'element ecris 1000 -> 20
// modif chaine de caracteres dans wrbuf pour mettre CRLF en fin de buffer
// pour faciliter l'affichage terminal
// ===>  File TEST + LNF_TEST  ... OK

//#define Version "2020_1103"
// test SDCARD  mikroC librairie FAT32
// 1er Test avec #define LFN_TEST ..................OK

 #define Directory  "C:\\_MikroC\\_MesProjets_MikroC\\_BASE_18F26K22 "
 #define Project   "SD_FAT32_512_sur_BASE_18F26K22_2020_11.mcppi"
 #define Source     "Base_18F26K22_MMC_SDCARD_Test_FAT32_512"
 #define HARDWARE  "Carte Base 18F26K22  (PDIP 28 Pins)"
 #define FOSC_INTERNE   // 16MHz x PLL
 #define CONFIG "P18F26K22_FOSC_interne_16xPLL_64MHz_RA6_FreqOut.cfgsch"
 #define LIBRARIES  "additional FAT32 Library"
 #define FOSC "64MHz"
 #define MCU  "18F26K22"
 #define POWER_Supply "5.0V"
 
 /*
 CONFIG1H : $300001 : 0x0039
CONFIG2L : $300002 : 0x001F
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x00BF
CONFIG4L : $300006 : 0x0081
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040
*/


 // liste des fichiers Fat32 libbb
 //ac:fat32_lib
 
 //  interconection PIC <---> SDCARD
 //   ac:Scard_links
 
 // photo carte support SDCARD
  //ac:photo_SDCARD
 
 
 
 
 
 
 
 
/*
 HARDDWARE:
 Pin 28 RB7  -----------------ICSP Data
 Pin 27 RB6  -----------------ICSP Clock
 Pin 26 RB5
 Pin 25 RB4
 Pin 24 RB3
 Pin 23 RB2
 Pin 22 RB1
 Pin 21 RB0
 Pin 20 VDD --------+5V
 Pin 19 Vss ---------Gnd
 Pin 18 RC7  RX UART  <-- Keyboard  * pull up de 10K si RX non utilise
 Pin 17 RC6  TX UART  --> Display
 Pin 16 RC5  SPI MOSI ----------------> MMC SDCARD
 Pin 15 RC4  SPI MISO  <--------------- MMC SDCARD

 Pin 14 RC3   SPI  SCLK --------------> MMC SDCARD
 Pin 13 RC2
 Pin 12 RC1  --> SQA trig.for Analyser
 Pin 11 RC0  CS ------------------------MMC SDCARD
 Pin 10 RA6  --> output fOSC/4
 Pin  9 RA7
 Pin  8 VSS ---------  Gnd
 Pin  7 RA5
 Pin  6 RA4  Output -- Led Rouge -- 2,7K --+Vcc
 Pin  5 RA3
 Pin  4 RA2  optional  Analog output(DAC)
 Pin  3 RA1  <--- OWS DS18B20 input
 Pin  2 RA0  <-----Analog Input EA0
 Pin  1 RE3 MCLR  Reset --------ICSP PGRM
 */
 
#include "__Lib_FAT32.h"

#define Print UART1_Write_Text
//#define CR 13
//#define LF 10
#define TAB 9
#define BACK 8

////////////////////////////////
//#define DIR_TEST_1
//#define DIR_TEST_2
#define FILE_TEST
//#define SWAP_TEST
#define LFN_TEST

////////////////////////////////////////////////////////////////
//    Mmc Library requirements for different MPU families
////////////////////////////////////////////////////////////////

sbit Mmc_Chip_Select  at RC0_bit;
sbit Mmc_Chip_Select_Direction at TRISC0_bit;

sbit SQA  at LATA.B5;
sbit SQA_Dir at TRISA.B5;
sbit Led_On_RA4 at LATA4_bit;      //tirage au +VCC via 2,7K
sbit Led_On_RA4_Dir at TRISA4_bit;

////////////////////////////////////////////////////////
//  many of these messages are not used in the example,
//  as they are intended for future improvement
////////////////////////////////////////////////////////

const char cmd[16][16] =
{
    "init           ",    //  0
    "qformat        ",    //  1
    "mkdir          ",    //  2
    "chdir          ",    //  3
    "rmdir          ",    //  4
    "dir            ",    //  5
    "rendir         ",    //  6
    "assign         ",    //  7
    "read           ",    //  8
    "append         ",    //  9
    "rewrite        ",    // 10
    "delete         ",    // 11
    "rename         ",    // 12
    "swap           ",    // 13
    "set date       ",    // 14
    "get date       "     // 15
};

const char cmdOK[16][16] =
{
    "init ok        ",
    "qformat ok     ",
    "mkdir ok       ",
    "chdir ok       ",
    "rmdir ok       ",
    "dir ok         ",
    "rendir ok      ",
    "assign ok      ",
    "read ok        ",
    "append ok      ",
    "rewrite ok     ",
    "delete ok      ",
    "rename ok      ",
    "swap ok        ",
    "set date ok    ",
    "get date ok    "
};

const char cmdFAIL[16][16] =
{
    "init failed    ",
    "qformat failed ",
    "mkdir failed   ",
    "chdir failed   ",
    "rmdir failed   ",
    "dir failed     ",
    "rendir failed  ",
    "assign failed  ",
    "read failed    ",
    "append failed  ",
    "rewrite failed ",
    "delete failed  ",
    "rename failed  ",
    "swap failed    ",
    "set date failed",
    "get date failed"
};

const char len[16] =
{
    4,
    7,
    5,
    5,
    5,
    3,
    6,
    6,
    4,
    6,
    7,
    6,
    6,
    4,
    8,
    8
};

const char line[16]         =   "===============";
const char unknown[16]      =   "unknown command";
const char startOK[16]      =   "init successful";
const char startFAIL[16]    =   "init failed    ";
const char cmdStart[16]     =   "cmd demo start ";
const char noFileName[16]   =   "NO FILE NAME   ";
const char noDirName[16]    =   "NO DIR NAME    ";
const char noVolumeName[16] =   "NO VOLUME NAME ";
const char fat32Version[16] =   "FAT32 Library v";

unsigned char TEXTE[80];
unsigned char buffer1[80];
char CRam1[32];
char *p1 ;
char * txt;

volatile char  c1,c2;cx;
volatile int DataReady1;
volatile int CptFO1,CptFE1;
volatile int Index1,i1;
int erreurs;
unsigned int  Count1;
int Flag_Timer1, NbCycles_T1;
unsigned long L1;

signed char   err;
unsigned int i,j,m;
unsigned char attr;

unsigned int cnt, bpcl;
uint32_t k;
unsigned long fileSize;
unsigned long  totalClusts;
unsigned long  freeClusts;
unsigned long  badClusts;

__TIME tm;
__SECTOR sc;
__HANDLE fileHandle[4];

char ch;
char DirName[20];
char FileName[20];
//char uartbuf[32];
char del[2] = "\r";
// 20 spaces
char rdbuf[20] = {'1','2','3','4','5','6','7','8','9','0','1','2','3','4','5','6','7','8','9',0};
char wrbuf[16] = {'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', '.',13,10,0};
char buff[512];

void Interrupts_High() iv 0x0008 ics ICS_AUTO
{
  if((RC1IE_bit==1)&& (PIR1.RC1IF==1)) // si une interruption UART1 arrive
  {
   c1 =RC1REG; // le lire => RAZ  RCIF
   if(RCSTA1.FERR==1 )
    {
     RCSTA1.SPEN = 0 ;
     CptFE1++;
     RCSTA1.SPEN= 1 ;
     c1=0;
    }
    if (RCSTA1.OERR==1)    // voir parag 16.1.26 p273
    {
       RCSTA1.CREN = 0 ;
       CptFO1++;
       RCSTA1.CREN = 1 ;
       c1=0;
    }
    if(c1 != CR )
    {
      buffer1[i1] = c1;
      Index1=i1;
      i1++;
      if (i1>79)
      {
        DataReady1=2;
        RC1IE_bit=0;
        buffer1[i1-1]=0;
        Index1=i1;
        i1=0;
      }
      else
      DataReady1 = 0;
       }
       else
        {
         buffer1[i1] = 0;         //  0 a la fin du string
        DataReady1 = 1;      // drapeau Data recue
        Index1=i1;
        i1=0;
     }

   PIR1.RC1IF=0;
   } //if PIR1
    // ------  timer 1  ----------------
 if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Count1++;
     if (Count1>=NbCycles_T1)   // 8x125 ms= 1 seconde   et init timer1  3035  et prescaler=1/8
       {
        Count1=0;
        Flag_Timer1=1;
        TMR1IE_bit=0;
      }
      TMR1H= 0x0B; // Hi (3035);
      TMR1L= 0xDB; // Lo (3035);
      PIR1.TMR1IF=0;
   }
 }
///////////////

static char* constToVar(char *dst, const char *src)
{
    char *tmp;
    tmp = dst;
    for (;;)
    {
        *dst = *src;
        if (*src == 0) break;
        src++;
        dst++;
    }
    return tmp;
}

/*
char iscmd(char n)
{
    if (0 == memcmp(uartbuf, constToVar(varbuf, cmd[n]), len[n]))
        return 1;
    else
        return 0;
}
*/

void CPrint(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
 }

 void CRLF1(void)
 {
      UART1_Write(CR);
      UART1_Write(LF);
 }

/* ------------------------------------------------------------*/

//  https://www.edaboard.com/threads/sd-card-initialization-failed-help.395564/
// SD Card Initialization failed. Help.
//   05/11/2020         Thread starterRickooo  Start dateYesterday at 5:44 PM
/*
unsigned char SDdata[16];
unsigned char SDcommand[8];
void Command(char cmd, unsigned long int arg, char CRCbits);
void dummy_clock(int n)  ;
void  spi_send(char * Table, int n)  ;
void proceed(void)   ;
unsigned char response(void)  ;
void SDcard_Init(void);


void Command(char cmd, unsigned long int arg, char CRCbits)
{
    unsigned char temp;
    SPI_Write(0xFF);  //Dummy Byte
   SPI_Write(cmd);
   SPI_Write((unsigned char) (arg >> 24));
   SPI_Write((unsigned char) (arg >> 16));
   SPI_Write((unsigned char) (arg >> 8));
   SPI_Write((unsigned char)  arg);
   SPI_Write(CRCbits);
}

 void dummy_clock(int n)
 {
  proceed();
}

void  spi_send(char * Table, int n)
{
  int i;
   Mmc_Chip_Select = 1; // set CS high
  for (i=0;i<n;i++) 
  {
    SPI_Write (*(Table+i));
  }
   Mmc_Chip_Select = 0;
}

 void proceed()
 {
    Mmc_Chip_Select = 1; // set CS high
    SPI_Write(0xFF);
    Mmc_Chip_Select = 0;
}


unsigned char response()
{  char buff, c;
    Mmc_Chip_Select  = 1;          //CS low
    c= SPI_Read(buff);
    //spi_single_receive();
    return buff;
}

 void SDcard_Init(void)
 { static unsigned char count, buff;
      count = 0;
    // send debug message
  //  LATCbits.LATC5 = 1;
    CPrint("Starting SD card initialization...\r\n");
    // dummy clock  
    LATA.B4=0;
    do{
    dummy_clock(40);
    // transmit command 0
    SDcommand[0] = 0x40; // start bit | host bit | command
    SDcommand[1] = 0x00; // no arguments
    SDcommand[2] = 0x00;
    SDcommand[3] = 0x00;
    SDcommand[4] = 0x00;
    SDcommand[5] = 0x95; // pre-calculated CRC

    CPrint("Sent CMD0 Command\t");

      spi_send(SDcommand, 6);
      buff = response();
      count++;

       _asm{
         BTG LATA,4,0    ; // clignote led sur RA4
              }
     CPrint(" Essai # ");
     UART1_Write(count/10+48);UART1_Write(count%10+48);
     UART1_Write(TAB);
    ByteToStr(buff,CRam1);
    CPrint(" Buff= ");
    Print (CRam1);
    CRLF1();
        Delay_ms(100);
     }
     while((buff!=0X01) && (count<20) );

   if  (buff==0X01)
   {
    CPrint("CMD0 success!\r\n");  //Now Card enter in SPI mode
    }

 }
 
 run
 
    // SDcard_Init();
    /*
    Starting SD card initialization...
    Sent CMD0 Command         Essai # 01         Buff=   0
    Sent CMD0 Command         Essai # 02         Buff=   0
          ...
    Sent CMD0 Command         Essai # 20         Buff=   0
    while(1);
    */


void main(void)
{
  OSCTUNE=0;
  OSCCON = 0b01110000  ; //0x70 ;     //Oscillateur  16 Mhz
  OSCTUNE.PLLEN=1;  // TUN=0     PLLEN activ => 16x4 = 64 MHz
  while (OSCCON.HFIOFS==0); // wait stable oscillator
  
   ANSELA=0x01;
   ANSELB=0;
   ANSELC=0;

    //  UART module initialization
    UART1_Init(19200);
    Delay_ms(100);
    

    // ---- Presentation ---------------

  Print(" MCU : " MCU"\r\n");
  Print(" Power supply: "POWER_Supply"\r\n");
  Print(" Directory : " Directory"\r\n");
  Print(" Projet : " Project"\r\n");
  Print(" Source : "Source" version "Version"\r\n");
  Print(" FOSC  : " FOSC"\r\n");
  Print(" Hardware : " HARDWARE"\r\n");

   Delay_1sec();     // wait a second

    CRLF1();
    CPrint(line);    CRLF1();
    CPrint(fat32Version);
    CPrint(FAT32_getVersion());    CRLF1();
    CPrint(line);    CRLF1();
    Delay_ms(100);

    //  SPI module initialization
    //initSPI();
    CPrint(" Init SPI faible Vitesse OSC_DIV64  \r\n");
    SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
    
    //  initialize storage device.
    //  optionally, we could format the device
    //  instead of just initializing it.
    err=1;
    err = FAT32_Init();
    //err = FAT32_format("dev0");
    if (err < 0)
    {
           CRLF1();
            CPrint(" Retour = ");
            CPrint(cmdFAIL[0]);
           CRLF1();
            while(err < 0)  //  ...retry each second
            {
                    err = FAT32_Init();
                    Delay_ms(1000);
            }
    }
    // ---------------------------------------------------------------------------
    // Si tout s'est bien pass, reinitialisation SPI  grande vitesse :  x 16 !
    //  Eh bien,NON, a ne va plus ..
    // il faut donc se contenter d'une vitesse moyenne , mais x 4
    //if all went well, reinitialize
    //  SPI with greater speed
    //----------------------------------------------------------------------------
    CPrint(" Init SPI Moyenne Vitesse OSC_DIV16 ! (donc  x 4 ) \r\n");
    SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV16, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
    CRLF1();
    CPrint(cmdOK[0]);
    CRLF1();

    CPrint(" Fat32 dir : \r\n");
    err = FAT32_Dir();
    CRLF1();
    ByteToStr(err,CRam1);
    CPrint(" retour err = ");
    Print(CRam1);
    CRLF1();

      CPrint(line);    CRLF1();

    //  In this section folder operation is demonstrated:
    //      - folder creation (all files are left empty, however)
    //      - entering in and out of a folder
    //      - removal of a folder and it's contents
    //      - display of folder contents
    #ifdef DIR_TEST_1
    {   
        CRLF1();
        CPrint("===========\r\n");
        CPrint(" DIR_TEST1 \r\n");
        CPrint("===========\r\n");
           CRLF1();
            tm.Year   = 2020;   // initialize time ...
            tm.Month  = 12;
            tm.Day    = 11;
            tm.Hour   = 10;
            tm.Minute = 20;
            tm.Second = 11;

           FAT32_SetTime(&tm);     // ...and set global time stamps
           FAT32_IncTime(2*60*60 + 30*60 + 40);  // increment time stamp by 2 hours, 30 minutes and 40 seconds
           err = 0;
           memset(DirName, 0, 9);
           for (i = 'A'; i <= 'Z'; i++)
            {
                    memcpy (DirName, "DIR_", 5);
                    DirName[3] = i;

                    err = FAT32_MakeDir(DirName);
                    err = FAT32_ChangeDir(DirName);
                    for (j = 'A'; j <= 'Z'; j++)
                    {
                            FAT32_IncTime(20*60 + 10);      // increment time stamp some more
                            memcpy(FileName, "FILE__.TXT", 11);
                            FileName[4] = i;
                            FileName[5] = j;
                            fileHandle[0] = FAT32_Open(FileName, FILE_APPEND);
                            if (fileHandle[0] < 0)
                            {
                                    UART_Write(i);
                                    UART_Write(j);
                                    while(1);
                            }
                            err = FAT32_Close(fileHandle[0]);

                            // get create and modification time stamps
                            // they should be 20*60 + 10 seconds apart
                            FAT32_GetCTime(FileName, &tm);
                            FAT32_GetMTime(FileName, &tm);
                    }
                    {
                            FAT32_IncTime(20*60 + 10);
                            err = FAT32_MakeDir("DIRX");
                            err = FAT32_Dir();
                           CRLF1();
                            err = FAT32_ChangeDir("DIRX");
                            fileHandle[0] = FAT32_Open("FILEX.TXT", FILE_WRITE);
                            if (fileHandle[0] < 0)
                            {
                                    UART_Write(i);
                                    UART_Write(j);
                                    while(1);
                            }
                            err = FAT32_Close(fileHandle[0]);
                            //err = FAT32_ChangeDir("..");
                            err = FAT32_Dir();
                           CRLF1();
                            err = FAT32_ChangeDir("\\"); // get back to the root directory.
                    }
                    //err = FAT32_ChangeDir("..");
                    err = FAT32_Dir();
                   CRLF1();
            }
            for (i = 'A'; i <= 'Z'; i++)
            {
                    memcpy (DirName, "DIR_", 5);
                    DirName[3] = i;
                    err = FAT32_DeleteRec(DirName);
                    err = FAT32_Dir();
                   CRLF1();
            }
            err = FAT32_Dir();
           CRLF1();
    }
    #endif


  // In this section creation and removal of a deep directory tree is demonstrated

    #ifdef DIR_TEST_2
    {   
        CRLF1();
        CPrint("===========\r\n");
        CPrint(" DIR_TEST_2 \r\n");
        CPrint("===========\r\n");
        CRLF1();
            tm.Year   = 2020;
            tm.Month  = 11;
            tm.Day    = 20;
            tm.Hour   = 10;
            tm.Minute = 40;
            tm.Second = 29;

            FAT32_SetTime(&tm);
            FAT32_IncTime(1282);

            err = 0;
            memset(DirName, 0, 9);
            for (i = 'A'; i <= 'Z'; i++)
            {
                    memcpy (DirName, "DIR_", 5);
                    DirName[3] = i;

                    err = FAT32_MakeDir(DirName);
                    err = FAT32_Dir();
                   CRLF1();
                    err = FAT32_ChangeDir(DirName);
                    for (j = 'A'; j <= 'Z'; j++)
                    {
                            memcpy(FileName, "FILE__.TXT", 11);
                            FileName[4] = i;
                            FileName[5] = j;
                            fileHandle[0] = FAT32_Open(FileName, FILE_APPEND);
                            if (fileHandle[0] < 0)
                            {
                                    UART_Write(i);
                                    UART_Write(j);
                                    while(1);
                            }
                            err = FAT32_Close(fileHandle[0]);
                    }
            }
            for (i = 'A';;)
            {
                    memcpy (DirName, "DIR_", 5);
                    DirName[3] = i;
                    err = FAT32_ChangeDir("\\"); // get back to the root directory.
                    err = FAT32_Dir();
                   CRLF1();
                    err = FAT32_DeleteRec(DirName);
                    err = FAT32_Dir();
                   CRLF1();
                    break;
            }
    }
    #endif

    //  In this section file operation is demonstrated:
    //      - read,
    //      - write,
    //      - append,
    //      - removal.
    //  User might wish to try seek, rename, etc.

    #ifdef FILE_TEST
    {
        CRLF1();
        CPrint("===========\r\n");
        CPrint(" FILE_TEST \r\n");
        CPrint("===========\r\n");
        CRLF1();
        CPrint(" Write Buffer wrbuf = ");
        Print(wrbuf);  CRLF1();
        CPrint(" Size of Write Buffer = ");
        m= sizeof(wrbuf);
        WordToStr(m,CRam1);
        Print(CRam1);
        CRLF1();


              if (FAT32_Exists("FILE1.TXT"))
            {
                   CPrint("Deleting existing \"FILE1.TXT\"...\r\n");
                    FAT32_Delete("FILE1.TXT");
                    err = FAT32_Dir();
                   CRLF1();
            }

           CRLF1();
           CPrint("Open File \"FILE1.TXT\" \r\n");
           // open some files
           fileHandle[0] = FAT32_Open("FILE1.TXT", FILE_WRITE);
           FAT32_Seek(fileHandle[0], 0);   // reset file cursor to 0.
           // fileHandle[1] = FAT32_Open("FILE2.TXT", FILE_APPEND);
           //  fileHandle[2] = FAT32_Open("FILE3.TXT", FILE_APPEND);
           //  fileHandle[3] = FAT32_Open("FILE4.TXT", FILE_APPEND);

           // BLOCAGE SI PROBLEME !! PAS BIEN !!
            if (fileHandle[0] < 0) while(1);
           //  if (fileHandle[1] < 0) while(1);
           //  if (fileHandle[2] < 0) while(1);
           //  if (fileHandle[3] < 0) while(1);
          CPrint(" Ecriture de 10 fois wrbuff  \r\n");
          //VO
          //  for (k = 0; k < 1000; k++)
          for (k = 0; k < 10; k++)
           {
            wrbuf[12]=k+48;
            Print(wrbuf);
            err = FAT32_Write(fileHandle[0], wrbuf, sizeof(wrbuf));
           }
          CRLF1();
          CPrint(" Close \"FILE1.TXT\" \r\n");
          err = FAT32_Close(fileHandle[0]);
          CPrint(" DIR \r\n");
          err = FAT32_Dir();
          CRLF1();

          CPrint("\r\n Ouverture en Lecture de \"FILE1.TXT\" \r\n");
          fileHandle[0] = FAT32_Open("FILE1.TXT", FILE_READ);
          if (fileHandle[0] < 0) while(1);
          m= sizeof(rdbuf);
          CPrint(" Size of Read Buffer = ");
          WordToStr(m,CRam1); Print(CRam1); CRLF1();
          CPrint(" Lecture de \"FILE1.TXT\" \r\n");
          err = FAT32_Size("FILE1.TXT", &fileSize);
          for (k = 0; k < fileSize;)
            {
              //VO
              // err = FAT32_Read(fileHandle[0], rdbuf, sizeof(rdbuf));
              // for (cnt = 0; cnt < sizeof(rdbuf); cnt++, k++)
              err = FAT32_Read(fileHandle[0], rdbuf,m);
              for (cnt = 0; cnt < m; cnt++, k++)
               {
                   if (k < fileSize)
                   {
                     UART_Write(rdbuf[cnt]);
                   }
                   else
                   {
                   break;
                   }
               }
            }
           CRLF1();

        /*  to test later
            FAT32_Seek(fileHandle[0], 0);   // reset file cursor to 0.
            // FAT32_Seek(fileHandle[0], 5789); // it can be changed to anywhere within a file.
            // read 'rdlen' bytes in "FILE1.TXT" from the position set by FAT32_Seek()
            // and write them to "FILE2.TXT" and "FILE3.TXT"
            err = FAT32_Read (fileHandle[0], rdbuf, sizeof(rdbuf));
            err = FAT32_Write(fileHandle[1], rdbuf, sizeof(rdbuf));
            err = FAT32_Write(fileHandle[2], rdbuf, sizeof(rdbuf));

            // read 3x'rdlen' bytes in "FILE1.TXT" from the current position
            // and write them to "FILE4.TXT"
            err = FAT32_Read (fileHandle[0], rdbuf, sizeof(rdbuf));
            err = FAT32_Write(fileHandle[3], rdbuf, sizeof(rdbuf));
            err = FAT32_Read (fileHandle[0], rdbuf, sizeof(rdbuf));
            err = FAT32_Write(fileHandle[3], rdbuf, sizeof(rdbuf));
            err = FAT32_Read (fileHandle[0], rdbuf, sizeof(rdbuf));
            err = FAT32_Write(fileHandle[3], rdbuf, sizeof(rdbuf));

            // close all opened files
            err = FAT32_Close(fileHandle[0]);
            err = FAT32_Close(fileHandle[1]);
            err = FAT32_Close(fileHandle[2]);
            err = FAT32_Close(fileHandle[3]);
          */
            err = FAT32_Close(fileHandle[0]);
            // display new info on modified files.
            // the info is updated only after file closure.
            err = FAT32_Dir();
            CRLF1();

            // change attribute "FILE1.TXT"
            err = FAT32_GetAttr("FILE1.TXT", &attr);
            err = FAT32_SetAttr("FILE1.TXT", attr | ATTR_HIDDEN);
            err = FAT32_Dir();
            CRLF1();
    }
    #endif

    //  In this section creation of a swap file is demonstrated.
    //  'sc' variable points to the 1st sector of the swap file,
    //  if the user needs access to it via readSector and writeSector
    //  routines.

    #ifdef SWAP_TEST
    {
           
        CRLF1();
        CPrint("===========\r\n");
        CPrint(" SWAP_TEST \r\n");
        CPrint("===========\r\n");
        CRLF1();
            // delete already existing swap file
            if (FAT32_Exists("SWAP.TXT"))
            {
                   CPrint("Deleting existing swap file...");
                   CRLF1();
                    FAT32_Delete("SWAP.TXT");
                    err = FAT32_Dir();
                   CRLF1();
            }

           CPrint("Creating new swap file...");
           CRLF1();
           err = FAT32_MakeSwap("SWAP.TXT", 512, &sc);  // if swap file creation was successful,
                                                                                                            // we can access it with
            fileHandle[0] = FAT32_Open("SWAP.TXT", FILE_READ);
            if (fileHandle[0] < 0) while(1);
            err = FAT32_Close(fileHandle[0]);
            err = FAT32_Dir();
            CRLF1();

            // fill swap file using sector based access
            if (sc) {
             CPrint"Fill swap file using sector based access...");
             CRLF1();
             CPrint("Start sector:");
             LongWordToStr(sc,CRam1);
             UART_Write_Text(CRam1);
             CRLF1();
             CPrint(" Fill Buff with ascii values ");
             for(cnt=0; cnt<512; cnt++)  buff[cnt] = 32+(cnt%64);
             for(k=0; k<8; k++)
              {
               CPrint(" Write Sector # ");
               UART_Write_Text(k+48);
               FAT32_Dev_Write_Sector(sc++, buff);
               UART_Write('.');
               if((k%64)==0) CRLF1();
              }
             CRLF1();
            }
           err = FAT32_Dir();
           CRLF1();
    }
    #endif

    //  In this section long file name use is demonstrated
    #ifdef LFN_TEST
        CRLF1();
        CPrint("=====================\r\n");
        CPrint(" Demo LFN_TEST       \r\n");
        CPrint("=====================\r\n");
        CPrint(" Make long Name DIR \r\n");
        for (i = 'A'; i <= 'C'; i++) {
            memcpy (DirName, "Long _ Name", 12);
            DirName[5] = i;

            err = FAT32_MakeDir(DirName);
            err = FAT32_Dir();
           CRLF1();
        }
        CPrint(" Change DIR \r\n");
        err = FAT32_ChangeDir(DirName);
        err = FAT32_Dir();
       CRLF1();

        for (i = 'A'; i <= 'C'; i++) {
            memcpy (DirName, "Same Short Name _", 18);
            DirName[16] = i;

            err = FAT32_MakeDir(DirName);
            err = FAT32_Dir();
           CRLF1();
        }

        for (i = 'A'; i <= 'C'; i++) {
            memcpy (DirName, "Same Short Name _", 18);
            DirName[16] = i;

            err = FAT32_Delete(DirName);
            err = FAT32_Dir();
           CRLF1();
        }

        err = FAT32_ChangeDir("..");
        err = FAT32_Dir();
       CRLF1();

        for (i = 'A'; i <= 'C'; i++) {
            memcpy (DirName, "Long _ Name", 12);
            DirName[5] = i;

            err = FAT32_Delete(DirName);
            err = FAT32_Dir();
           CRLF1();
        }
    #endif
    
     CPrint("\r\n Ouverture en Lecture de \"X_FILES.TXT\" \r\n");
     fileHandle[0] = FAT32_Open("X_FILES.TXT", FILE_READ);
     if (fileHandle[0] < 0) while(1);
     m= sizeof(rdbuf);
     CPrint(" Lecture de \"X_FILES.TXT\" \r\n");
     err = FAT32_Size("X_FILES.TXT", &fileSize);
     CPrint("\r\n----------------------------------------------------------\r\n");
            for (k = 0; k < fileSize;)
            {
              //VO
              // err = FAT32_Read(fileHandle[0], rdbuf, sizeof(rdbuf));
              // for (cnt = 0; cnt < sizeof(rdbuf); cnt++, k++)
              err = FAT32_Read(fileHandle[0], rdbuf,m);
              for (cnt = 0; cnt < m; cnt++, k++)
               {
                   if (k < fileSize)
                   {
                     UART_Write(rdbuf[cnt]);
                   }
                   else
                   {
                   break;
                   }
               }
            }
      CPrint("\r\n----------------------------------------------------------\r\n");
      CRLF1();
      err = FAT32_Close(fileHandle[0]);
      err = FAT32_Dir();
      CRLF1();

    CRLF1();
    FAT32_GetFreeSpace(&freeClusts, &bpcl);
    CPrint("Free Space Info:\r\n");
    CPrint("Free clusters: ");
    LongWordToStr(freeClusts, CRam1);
    Print(CRam1);
    CRLF1();
    CPrint("Free bytes: ");
    LongWordToStr(freeClusts*bpcl, CRam1);
    Print(CRam1);
    CRLF1();

    CRLF1();
    FAT32_ScanDisk(&totalClusts, &freeClusts, &badClusts);
     CPrint("=================\r\n");
    CPrint(" Scan Disk Info:\r\n");
    CPrint("Total clusters: ");
    LongWordToStr(totalClusts, CRam1);
    UART_Write_Text(CRam1);
    CRLF1();
    CPrint("Free clusters: ");
    LongWordToStr(freeClusts, CRam1);
    UART_Write_Text(CRam1);
    CRLF1();
    CPrint("Bad clusters: ");
    LongWordToStr(badClusts, CRam1);
    UART_Write_Text(CRam1);
    CRLF1();
    CPrint("=================\r\n");
    CRLF1();
}

/*
   MCU : 18F26K22
 Power supply: 5.0V
 Directory : C:\_MikroC\_MesProjets_MikroC\_BASE_18F26K22
 Projet : SD_FAT32_512_sur_BASE_18F26K22_2020_11.mcppi
 Source : Base_18F26K22_MMC_SDCARD_Test_FAT32_512 version 2020_1108
 FOSC  : 64MHz
 Hardware : Carte Base 18F26K22  (PDIP 28 Pins)

===============
FAT32 Library v3.2.2.0
===============
 Init SPI faible Vitesse OSC_DIV64
 Init SPI Moyenne Vitesse OSC_DIV16 ! (donc  x 4 )

init ok
 Fat32 dir :

MMC:\
----L---           00/00/0000 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A---H-       160 00/00/2048 00:00 FILE1.TXT

 retour err =   0
===============

===========
 FILE_TEST
===========

 Write Buffer wrbuf = ABCDEFGHIJKL.

 Size of Write Buffer =    16
Deleting existing "FILE1.TXT"...

MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT


Open File "FILE1.TXT"
 Ecriture de 10 fois wrbuff
ABCDEFGHIJKL0
ABCDEFGHIJKL1
ABCDEFGHIJKL2
ABCDEFGHIJKL3
ABCDEFGHIJKL4
ABCDEFGHIJKL5
ABCDEFGHIJKL6
ABCDEFGHIJKL7
ABCDEFGHIJKL8
ABCDEFGHIJKL9

 Close "FILE1.TXT"
 DIR

MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A-----       160 00/00/2048 00:00 FILE1.TXT


 Ouverture en Lecture de "FILE1.TXT"
 Size of Read Buffer =    20
 Lecture de "FILE1.TXT"
ABCDEFGHIJKL0
<NUL>ABCDEFGHIJKL1
<NUL>ABCDEFGHIJKL2
<NUL>ABCDEFGHIJKL3
<NUL>ABCDEFGHIJKL4
<NUL>ABCDEFGHIJKL5
<NUL>ABCDEFGHIJKL6
<NUL>ABCDEFGHIJKL7
<NUL>ABCDEFGHIJKL8
<NUL>ABCDEFGHIJKL9
<NUL>

MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A-----       160 00/00/2048 00:00 FILE1.TXT


MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A---H-       160 00/00/2048 00:00 FILE1.TXT


=====================
 Demo LFN_TEST
=====================
 Make long Name DIR

MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A---H-       160 00/00/2048 00:00 FILE1.TXT
---D----       DIR 00/00/2048 00:00 Long A Name


MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A---H-       160 00/00/2048 00:00 FILE1.TXT
---D----       DIR 00/00/2048 00:00 Long A Name
---D----       DIR 00/00/2048 00:00 Long B Name


MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A---H-       160 00/00/2048 00:00 FILE1.TXT
---D----       DIR 00/00/2048 00:00 Long A Name
---D----       DIR 00/00/2048 00:00 Long B Name
---D----       DIR 00/00/2048 00:00 Long C Name

 Change DIR

MMC:\Long C Name\
---D----       DIR 00/00/2048 00:00 .
---D----       DIR 00/00/2048 00:00 ..


MMC:\Long C Name\
---D----       DIR 00/00/2048 00:00 .
---D----       DIR 00/00/2048 00:00 ..
---D----       DIR 00/00/2048 00:00 Same Short Name A


MMC:\Long C Name\
---D----       DIR 00/00/2048 00:00 .
---D----       DIR 00/00/2048 00:00 ..
---D----       DIR 00/00/2048 00:00 Same Short Name A
---D----       DIR 00/00/2048 00:00 Same Short Name B


MMC:\Long C Name\
---D----       DIR 00/00/2048 00:00 .
---D----       DIR 00/00/2048 00:00 ..
---D----       DIR 00/00/2048 00:00 Same Short Name A
---D----       DIR 00/00/2048 00:00 Same Short Name B
---D----       DIR 00/00/2048 00:00 Same Short Name C


MMC:\Long C Name\
---D----       DIR 00/00/2048 00:00 .
---D----       DIR 00/00/2048 00:00 ..
---D----       DIR 00/00/2048 00:00 Same Short Name B
---D----       DIR 00/00/2048 00:00 Same Short Name C


MMC:\Long C Name\
---D----       DIR 00/00/2048 00:00 .
---D----       DIR 00/00/2048 00:00 ..
---D----       DIR 00/00/2048 00:00 Same Short Name C


MMC:\Long C Name\
---D----       DIR 00/00/2048 00:00 .
---D----       DIR 00/00/2048 00:00 ..


MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A---H-       160 00/00/2048 00:00 FILE1.TXT
---D----       DIR 00/00/2048 00:00 Long A Name
---D----       DIR 00/00/2048 00:00 Long B Name
---D----       DIR 00/00/2048 00:00 Long C Name


MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A---H-       160 00/00/2048 00:00 FILE1.TXT
---D----       DIR 00/00/2048 00:00 Long B Name
---D----       DIR 00/00/2048 00:00 Long C Name


MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A---H-       160 00/00/2048 00:00 FILE1.TXT
---D----       DIR 00/00/2048 00:00 Long C Name


MMC:\
----L---           00/00/2048 00:00 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A---H-       160 00/00/2048 00:00 FILE1.TXT


 Ouverture en Lecture de "X_FILES.TXT"
 Lecture de "X_FILES.TXT"

----------------------------------------------------------

ATTENTION : codage ANSI

Dim 01/11/2020
00:10 - 01:55
Court-circuit - Fete de l'animation
- "Le Monde en soi". animation de Sandrine Stoanov et Jean-Charles Finck (2020, 15mn).
- "Precieux".  d'animation (France, 2020, 11mn).
 - "Bach-Hang".  d'animation (France, 2019, 18mn).
 - "Cadavre exquis".  d'animation (France, 2018, 13mn). Short Cuts.
 - "Mr Mare".  d'animation de Luca Tath (France/Hongrie, 2019, 19mn

Drive
5 octobre 2011 / 1h 40min / Action, Thriller
Nationalite Americain
De :Nicolas Winding Refn
Avec : Ryan Gosling, Carey Mulligan, Bryan Cranston, Ron Perlmann Albert Brooks,
Ozscar Isaac, Christina Hendricks
Scenariste : Hossein Amini, D'apres l'oeuvre de James Sallis
Compositeur : Cliff Martinez, Eric Craig, ian McNelis
Un jeune homme solitaire, "The Driver", conduit le jour a Hollywood pour le cinema en tant
 que cascadeur et la nuit pour des truands. Ultra professionnel et peu bavard,
 il a son propre code de conduite. Jamais il n'a pris part aux crimes de ses employeurs
 autrement qu'en conduisant - et au volant, il est le meilleur !
Shannon, le manager qui lui decroche tous ses contrats, propose  Bernie Rose,
un malfrat notoire, d'investir dans un vehicule pour que son poulain puisse affronter
les circuits de stock-car professionnels. Celui-ci accepte mais impose son associe,
 Nino, dans le projet.
C'est alors que la route du pilote croise celle d'Irene et de son jeune fils.
Pour la premiere fois de sa vie, il n'est plus seul.
Lorsque le mari d'Irene sort de prison et se retrouve enrole de force dans un braquage
pour s'acquitter d'une dette, il decide pourtant de lui venir en aide.
L'expedition tourne mal !
Double par ses commanditaires, et obsede par les risques qui pesent sur Irene,
il n'a des lors pas d'autre alternative que de les traquer un  un !

----------------------------------------------------------


MMC:\
----L---           12/11/2020 13:59 MMC
---D-SH-       DIR 12/11/2020 11:44 System Volume Information
--A-----      1848 12/11/2020 13:59 X_FILES.TXT
--A---H-       160 00/00/2048 00:00 FILE1.TXT


Free Space Info:
Free clusters:    3792944
Free bytes: 1941987328

=================
 Scan Disk Info:
Total clusters:    3792953
Free clusters:    3792944
Bad clusters:          0
=================


0 1 mikroCPIC1618.exe -MSF -DBG -pP18F26K22 -RA -C -DL -O11111013 -fo64 -N"^C
C:\_MikroC\_MesProjets_MikroC\_BASE_18F26K22\SD_FAT32_512_sur_BASE_18F26K22_2020_11.mcppi" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\_BASE_18F26K22\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Packages\FAT32 Library\Uses\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\common\" -IP"^C
C:\_MikroC\mikroC PRO for PIC\uses\P18\" -IP"^C
C:\_MikroC\mikroC PRO for PIC\Packages\FAT32 Library\Uses\" -IP"^C
C:\_MikroC\_MesProjets_MikroC\_BASE_18F26K22\" "Base_18F26K22_MMC_SDCARD_Test_FAT32_512b_2020_1112.c" "
_Lib_Math.mcl" "
_Lib_MathDouble.mcl" "
_Lib_System.mcl" "
_Lib_Delays.mcl" "
_Lib_CString.mcl" "
_Lib_Conversions.mcl" "
_Lib_SPI_c345b123.mcl" "
_Lib_UART_c67b67.mcl" "
_Lib_Mmc.mcl" "
_Lib_FAT32_Driver.mcl" "
_Lib_FAT32_Defs.mcl" "
_Lib_FAT32.mcl"
0 1139 Available RAM: 3875 [bytes], Available ROM: 65536 [bytes]
0 122 Compilation Started P18F26K22.c
2623 123 Compiled Successfully P18F26K22.c
0 122 Compilation Started
_Lib_Delays.c
172 123 Compiled Successfully
_Lib_Delays.c
49 1354  warning: "/*" within comment ^C
C:\_MikroC\_MesProjets_MikroC\_BASE_18F26K22\Base_18F26K22_MMC_SDCARD_Test_FAT32_512b_2020_1112.c
0 122 Compilation Started stdint.h
0 1004 interrupt handler (Interrupts_High at 0x0008) Base_18F26K22_MMC_SDCARD_Test_FAT32_512b_2020_1112.c
1031 123 Compiled Successfully Base_18F26K22_MMC_SDCARD_Test_FAT32_512b_2020_1112.c
0 127 All files Compiled in 94 ms
0 1144 Used RAM (bytes): 2818 (73%)  Free RAM (bytes): 1057 (27%) Used RAM (bytes): 2818 (73%)  Free RAM (bytes): 1057 (27%)
0 1144 Used ROM (bytes): 46389 (71%)  Free ROM (bytes): 19147 (29%) Used ROM (bytes): 46389 (71%)  Free ROM (bytes): 19147 (29%)
0 125 Project Linked Successfully SD_FAT32_512_sur_BASE_18F26K22_2020_11.mcppi
0 128 Linked in 188 ms
0 129 Project 'SD_FAT32_512_sur_BASE_18F26K22_2020_11.mcppi' completed: 469 ms
0 103 Finished successfully: 12 nov. 2020, 14:11:36 SD_FAT32_512_sur_BASE_18F26K22_2020_11.mcppi



*/